import { Todo } from "../data";
import React, { useState } from "react";
import { connect } from "react-redux";
import { addTodo } from "../store/actions";

type TodoAdderProps = {
    add: (todo: Todo) => void
}

const TodoAdder = ({ add }: TodoAdderProps) => {
    const [ input, setInput ] = useState("");

    const create = () => {
        add && add({ description: input, done: false });
        setInput("");
    };

    return <div className="adder">
        <input className="adder__input" value={ input } onChange={ e => setInput((e.target as HTMLInputElement).value) }/>
        <button onClick={ create }>add</button>
    </div>
};

export default connect(null, { add: addTodo })(TodoAdder);