import React from "react";
import { connect } from "react-redux";
import { State } from "../store";
import * as filters from "../filters"
import { changeFilter } from "../store/actions";

type FiltersProps = {
    filters: string[],
    choose: (filter: string) => void,
};

const Filters = ({ filters, choose }: FiltersProps) => <ul className="filters">{
    filters.map(filter => <li className="filters__filter" key={ filter }>
        <button onClick={ () => choose(filter) }>{ filter }</button>
    </li>)
}</ul>;

const stateMapper = (state: State) => ({ filters: Object.keys(filters) });

export default connect(stateMapper, { choose: changeFilter })(Filters)