import { connect } from "react-redux";
import { toggleTodo } from "../store/actions";
import React from "react";
import { Todo } from "../data";

type TodoItemProps = {
    todo: Todo,
    index: number,
    toggle: typeof toggleTodo
}

export const TodoItem = ({ todo, index, toggle }: TodoItemProps) => <div className="todo" onClick={ () => toggle(index) }>
    <code>{ todo.done ? '[x]' : '[ ]' }</code>{ ' ' }
    { todo.description }
</div>;

export default connect(null, { toggle: toggleTodo })(TodoItem)
