import { Todo } from "../data";
import React from "react";
import { connect } from "react-redux";
import { TodoItem } from "./";
import { State } from "../store";

type TodoListProps = {
    items: Todo[]
}

const constant = value => () => value;
const stateMapper = ({ management, filter }: State): TodoListProps => ({
    items: management.items.filter(filter || constant(true) )
});

export const TodoList = ({ items }: TodoListProps) => items.length > 0 ? <ul className="todo-list">
    { items.map((todo, i) => <li key={ todo.description }>
        <TodoItem todo={ todo } index={ i }/>
    </li>) }
</ul> : <div className="alert">No todo items!</div>;

export default connect(stateMapper)(TodoList);