import { Todo } from "../data";

export const ADD_TODO = "ADD_TODO";
export const TOGGLE_TODO = "TOGGLE_TODO";

export interface AddTodoAction {
    type: typeof ADD_TODO,
    payload: Todo,
}

export interface ToggleTodoAction {
    type: typeof TOGGLE_TODO,
    payload: number,
}

export type TodoAction = AddTodoAction | ToggleTodoAction;

export type ManagementState = { items: Todo[] };

const initial: ManagementState = {
    items: [ { done: true, description: "test" } ],
};

export default function (state= initial, action: TodoAction): ManagementState {
    switch (action.type) {
        case "ADD_TODO":
            const todo = action.payload;
            return { ...state, items: [ ...state.items, todo ]};

        case "TOGGLE_TODO":
            const index = action.payload;

            const all = state.items.slice();
            all[index] = { ...all[index], done: !all[index].done };

            return { ...state, items: all };
    }

    return state;
}