const path = require('path');

module.exports = {
    devtool: "inline-source-map",
    resolve: {
        extensions: [".ts", ".tsx", ".js"]
    },
    output: {
        path: path.resolve('./public/')
    },
    module: {
        rules: [
            {
                test: /\.ts(x?)$/,
                exclude: /node_modules/,
                use: ["ts-loader"]
            }, {
                test: /\.s[ac]ss$/,
                use: ["style-loader", "css-loader?sourceMap", "sass-loader?sourceMap"]
            }, {
                test: /\.css$/,
                use: ["style-loader", "css-loader"]
            }, {
                test: /\.(png|svg|jpg|gif)$/,
                use: 'file-loader',
                exclude: [
                    path.resolve('./resources/icons')
                ]
            }, {
                test: /\.(woff|woff2|eot|ttf|otf)$/,
                use: 'file-loader'
            }
        ]
    },
    devServer: {
        contentBase: path.resolve("./public/"),
        port: 3000
    }
};